       subroutine rlsl(M,g,ga,gb,x,y,xhat,e,lambda,init)
       real g(0:M), ga(M), gb(M), lambda
 
       parameter (MAX = 50)
       real w0(MAX), w1(MAX)
       real e0a(0:MAX), e0b(0:MAX)
       real e1a(0:MAX), e1b(0:MAX)
       real D1a(0:MAX), D1b(0:MAX), D(0:MAX)
       integer p
       save w0, w1, D1a, D
 
       if (init .eq. 0) then
            do 1  p = 1, M
                  w0(p) = 0
                  w1(p) = 0
                  ga(p) = 0
                  gb(p) = 0
                  D1a(p) = 0
                  D(p) = 0
                  g(p) = 0
1          continue
            D1a(0) = 0
            D(0) = 0
            g(0) = 0
       endif
 
       e0b(0) = y
       e0a(0) = y
       e1b(0) = y
       e1a(0) = y
 
       D1a(0) = lambda * D1a(0) + e1a(0) * e0a(0)
       D1b(0) = lambda * D(0) + e1b(0) * e0b(0)
 
       e0 = x - g(0) * e0b(0)
       g(0) = g(0) + e0 * e1b(0) / D1b(0)
       xhat = g(0) * e1b(0)
       e = x - xhat
 
       do 2  p = 1, M
             e0a(p) = e0a(p-1) - gb(p) * w0(p)
             e0b(p) = w0(p) - ga(p) * e0a(p-1)
 
             if (p .le. init) then
                  ga(p) = ga(p) + e0b(p) * e1a(p-1) / D1a(p-1)
                  gb(p) = gb(p) + e0a(p) * w1(p) / D(p-1)
              endif
 
             e1a(p) = e1a(p-1) - gb(p) * w1(p)
             e1b(p) = w1(p) - ga(p) * e1a(p-1)
 
             D1a(p) = lambda * D1a(p) + e1a(p) * e0a(p)
             D1b(p) = lambda * D(p) + e1b(p) * e0b(p)
 
             w0(p) = e0b(p-1)
             w1(p) = e1b(p-1)
             D(p) = D1b(p)
 
             e0 = e0 - g(p) * e0b(p)

             if (p .le. init) then
                  g(p) = g(p) + e0 * e1b(p) / D1b(p)
             endif

             e = e - g(p) * e1b(p)
             xhat = xhat + g(p) * e1b(p)

2     continue
 
       D(0) = D1b(0)
 
       init = init + 1
 
       return
       end
