       subroutine scatter(M, rho, A, B, N, R)
       real rho(0:M), A(0:M, 0:M), B(0:M, 0:M), R(0:N-1)

       A(0, 0) = 1
       B(0, 0) = rho(0)

       do 1  i = 1, M
             A(i, 0) = 1
             A(i, i) = rho(0) * rho(i)
             B(i, 0) = rho(i)
             B(i, i) = rho(0)
             do 2  j = 1, i-1
                   A(i, j) = A(i-1, j) + rho(i) * B(i-1, j-1)
                   B(i, j) = B(i-1, j-1) + rho(i) * A(i-1, j)
2           continue
1     continue

       R(0) = B(M, 0)
       do 3  k = 1, N-1
             S = 0
             do 4  i = 1, min(k, M)
4                  S = S - A(M, i) * R(k-i)
             if (k .le. M) then
                  R(k) = B(M, k) + S
             else
                  R(k) = S
             endif
3     continue

       return
       end
