       subroutine schur1(M, R, gamma, G)
       real R(0:M), gamma(M), G(0:M, 0:M)

       parameter (MAX = 50)
       real ga(0:MAX)
       integer p

       do 1  k = 0, M
             ga(k) =  R(k)
             G(k, 0) = R(k)
1     continue

       do 2  p = 0, M-1      
             c = ga(p+1) / G(p, p)
             do 3  k = p+1, M
                   temp = ga(k)
                   ga(k) = temp - c * G(k-1, p)
                   G(k, p+1) = G(k-1, p) - c * temp
3           continue
             gamma(p+1) = c
2     continue

       return
       end
