       subroutine dpd(N, R, M, A, B, PHI, L, E)
       real R(0:N-1), A(0:M, 0:M), B(0:M, 0:M)
       real PHI(0:M), L(0:M, 0:M), E(0:M)


       call corr(N, R, R, M, PHI)

       do 1  k = 1, M
1            PHI(k) = -N * PHI(k)

       PHI(0) = 1 - N * PHI(0)

       call lev(M, PHI, L, E)

       do 2  i = 0, M
2            A(M, i) = L(M, M-i)

       do 3  i = 0, M
             B(M, i) = 0
             do 3  j = 0, i
                   B(M, i) = B(M, i) + A(M, j) * R(i-j)
3     continue

       rho0 = B(M, M)
       do 4  i = M, 1, -1
             rho = B(i, 0)
             F = 1 - rho ** 2
             do 5  j = 0, i-1
                   A(i-1, j) = ( A(i, j) - rho * B(i, j) ) / F
            B(i-1, j) = ( B(i, j + 1) - rho * A(i, j + 1) ) / F
5           continue
             A(i-1, 0) = 1
             B(i-1, i-1) = rho0
4     continue

       return
       end
