       subroutine schur(M, R, gamma, EM)
       real R(0:M), gamma(M)

       parameter (MAX = 50)
       real ga(0:MAX), gb(0:MAX)
       integer p

       do 1  k = 0, M
             ga(k) = R(k)
             gb(k) = R(k)
1     continue

       do 2   p = 0, M-1
              c = ga(p+1) / gb(p)
              do 3  k = M, p+1, -1
                    temp = ga(k)
                    ga(k) = temp - c * gb(k-1)
                    gb(k) = gb(k-1) - c * temp
3            continue
              gamma(p+1) = c
2     continue

       EM = gb(M)

       return
       end
