       subroutine spike(N, y, M, R, L, E, P, H, EPS)
       real y(0:N), R(0:M), L(0:M, 0:M), E(0:M)
       real P(0:N+M, 0:N+M), H(0:M, 0:N+M)

       integer s, t

       call corr(N+1, y, y, M, R)

       do 1  k = 0, M
1         R(k) = (N+1) * R(k)

       R(0) = (1 + EPS) * R(0)

       call lev(M, R, L, E)

       do 4  i = 0, M
          do 4  j = 0, N + M
             H(i, j) = 0
             do 4  s = i, M
                do 4  t = max(0, j-N), min(j, s)
      H(i, j) = H(i, j) + L(s, i) * L(s, t) * y(j-t) / E(s)
4     continue

       do 5  i = 0, N + M
             do 5  j = 0, N + M
                   P(i, j) = 0
                   do 5  t = max(0, i-N), min(i, M)
                         P(i, j) = P(i, j) + y(i-t) * H(t, j)
5     continue

       return
       end
